%clear all
%close all

load('data.mat')

%colors 
red=[1,0,0];  %red
green=[0,1,0];      %green
black=[0,0,0];    %black
blue=[0,0,1];      %blue
cyan=[0,1,1];      %cyan

% for each point in data, plot it
size_of_dataset=size(data);
for i=1:size_of_dataset(1)
    scatter(data(i,1),data(i,2),100,blue,'filled');
    hold on
end     

Init_positions = [10,10; 15,15; 30,5; 30,15]
NO_of_etalons = size(Init_positions);
for i = 1:NO_of_etalons(1)
    scatter(Init_positions(i,1),Init_positions(i,2),100,red,'filled');
    hold on  
end 
title('Init positions and dataset points')
%% your code here 
Etalons = Init_positions;
for iteration = 1:4 
    New_etalon=zeros(NO_of_etalons(1),3);
    for i=1:size_of_dataset(1)
       Point = data(i,:);
       %compute point - etalon distacne 
       for etNO = 1:NO_of_etalons(1)
            Etalon = Etalons(etNO,:);
            Distance(etNO) = sqrt((Point(1)-Etalon(1))^2+(Point(2)-Etalon(2))^2);
       end
       % find most suited etalon 
       [m,I]=min(Distance);
       New_etalon(I,:) = [New_etalon(I,1)+Point(1),New_etalon(I,2)+Point(2),New_etalon(I,3)+1];
    end
    %compute new etalons
    for etNO = 1:NO_of_etalons(1)
        Etalons(etNO,:) = [New_etalon(etNO,1)/New_etalon(etNO,3),New_etalon(etNO,2)/New_etalon(etNO,3)];
    end 
    
    %plot data 
    figure(1)
    clf
    for i=1:size_of_dataset(1)
        scatter(data(i,1),data(i,2),100,blue,'filled');
        hold on
    end     
    
    for i = 1:NO_of_etalons(1)
        scatter(Etalons(i,1),Etalons(i,2),100,red,'filled');
        hold on  
    end
    % labeling plots 
    str_e = sprintf('%d iterace',iteration)    
    title(str_e)
    %wait for action press
    keypress = waitforbuttonpress;
end 

